/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  if (!register_operand (operands[6], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[7] = x9;
  if (!register_operand (operands[7], E_SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  x11 = XEXP (x10, 0);
  operands[8] = x11;
  if (!register_operand (operands[8], E_SImode))
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!arith14_operand (operands[4], E_SImode))
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  x15 = XEXP (x14, 0);
  operands[5] = x15;
  if (!const_int_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 29
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 25
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 31
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  if (!r26_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[0] = x12;
  if (!div_operand (operands[0], E_SImode))
    return -1;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[2] = x14;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!arith14_operand (operands[2], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern52 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !tld_symbolic_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[0] = x4;
      if (!call_operand_address (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      x6 = XEXP (x5, 0);
      if (XWINT (x6, 0) != 0L)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      return 0;

    case REG:
      if (REGNO (x4) != 22
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      x6 = XEXP (x5, 0);
      if (XWINT (x6, 0) != 1L)
        return -1;
      x7 = XEXP (x2, 1);
      operands[0] = x7;
      x8 = XVECEXP (x1, 0, 3);
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      return 1;

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[3] = x4;
      if (!ordered_comparison_operator (operands[3], E_SImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith11_operand (operands[2], E_SImode))
        return -1;
      return 7; /* negscc */

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 139; /* *pa.md:6064 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 141; /* negsi2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 6280 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && !TARGET_PA_20))
            return 153; /* negdf2_slow */
          if (!
#line 6297 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
            return -1;
          return 154; /* negdf2_fast */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 6323 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && !TARGET_PA_20))
            return 155; /* negsf2_slow */
          if (!
#line 6331 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
            return -1;
          return 156; /* negsf2_fast */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern21 (x3, 
E_DFmode) != 0
              || !
#line 6422 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 165; /* *pa.md:6419 */

        case E_SFmode:
          if (pattern21 (x3, 
E_SFmode) != 0
              || !
#line 6430 "../../gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 166; /* *pa.md:6427 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern29 (x3, 
E_DFmode) != 0
              || !
#line 6479 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
            return -1;
          return 169; /* *pa.md:6475 */

        case E_SFmode:
          if (pattern29 (x3, 
E_SFmode) != 0
              || !
#line 6488 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
            return -1;
          return 170; /* *pa.md:6484 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_19 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return recog_16 (x1, insn, pnum_clobbers);

        case 8:
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case SET:
              x4 = XEXP (x3, 1);
              if (GET_CODE (x4) != MEM
                  || GET_MODE (x4) != E_BLKmode)
                return -1;
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_BLKmode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER
                  || pattern44 (x1, 
USE, 
CLOBBER) != 0)
                return -1;
              x7 = XEXP (x5, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_SImode)
                  || pattern3 (x1) != 0)
                return -1;
              return 71; /* cpymemsi_prereload */

            case CONST_INT:
              if (XWINT (x3, 0) != 2L)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern19 (x6, 
2) != 0
                  || pattern44 (x1, 
CLOBBER, 
USE) != 0
                  || pattern58 (x1) != 0)
                return -1;
              x9 = XVECEXP (x1, 0, 7);
              x10 = XEXP (x9, 0);
              operands[5] = x10;
              switch (GET_MODE (operands[5]))
                {
                case E_SImode:
                  if (!scratch_operand (operands[5], E_SImode)
                      || !
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                    return -1;
                  return 246; /* icacheflushsi */

                case E_DImode:
                  if (!scratch_operand (operands[5], E_DImode)
                      || !
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                    return -1;
                  return 247; /* icacheflushdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 9:
          x3 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x3) != SET)
            return -1;
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_BLKmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x11) != CLOBBER)
            return -1;
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != CLOBBER)
            return -1;
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != CLOBBER)
            return -1;
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != USE)
            return -1;
          x9 = XVECEXP (x1, 0, 7);
          if (GET_CODE (x9) != USE)
            return -1;
          x15 = XVECEXP (x1, 0, 8);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x16 = XEXP (x6, 0);
          operands[2] = x16;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x17 = XEXP (x11, 0);
          operands[3] = x17;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x18 = XEXP (x12, 0);
          operands[6] = x18;
          if (!register_operand (operands[6], E_SImode))
            return -1;
          x19 = XEXP (x14, 0);
          operands[4] = x19;
          if (!arith14_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x9, 0);
          operands[5] = x10;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x20 = XEXP (x13, 0);
          if (!rtx_equal_p (x20, operands[0]))
            return -1;
          x21 = XEXP (x2, 0);
          if (!rtx_equal_p (x21, operands[1])
              || !
#line 3438 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
            return -1;
          return 72; /* cpymemsi_postreload */

        case 5:
          return recog_17 (x1, insn, pnum_clobbers);

        case 6:
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != USE)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case SET:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != CLOBBER)
                return -1;
              x4 = XEXP (x3, 1);
              switch (GET_CODE (x4))
                {
                case CONST_INT:
                  if (XWINT (x4, 0) != 0L)
                    return -1;
                  x5 = XEXP (x3, 0);
                  if (GET_CODE (x5) != MEM
                      || GET_MODE (x5) != E_BLKmode)
                    return -1;
                  x12 = XVECEXP (x1, 0, 3);
                  if (GET_CODE (x12) != USE)
                    return -1;
                  x2 = XVECEXP (x1, 0, 5);
                  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x7 = XEXP (x5, 0);
                  operands[0] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x16 = XEXP (x6, 0);
                  operands[1] = x16;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x18 = XEXP (x12, 0);
                  operands[2] = x18;
                  if (!arith14_operand (operands[2], E_SImode))
                    return -1;
                  x20 = XEXP (x13, 0);
                  operands[3] = x20;
                  if (!const_int_operand (operands[3], E_SImode))
                    return -1;
                  x17 = XEXP (x11, 0);
                  if (!rtx_equal_p (x17, operands[0])
                      || !
#line 3740 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
                    return -1;
                  return 74; /* clrmemsi_postreload */

                case CALL:
                  x8 = XEXP (x4, 0);
                  if (GET_CODE (x8) != MEM
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x16 = XEXP (x6, 0);
                  if (GET_CODE (x16) != REG
                      || REGNO (x16) != 1
                      || GET_MODE (x16) != E_SImode
                      || pattern47 (x1) != 0)
                    return -1;
                  switch (pattern65 (x1))
                    {
                    case 0:
                      if (!
#line 8208 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 212; /* call_val_symref_pic */

                    case 1:
                      return 215; /* call_val_reg_pic */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case CALL:
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_SImode
                  || pattern26 (x1, 
CLOBBER, 
1) != 0
                  || pattern47 (x1) != 0)
                return -1;
              switch (pattern63 (x1))
                {
                case 0:
                  if (!
#line 7699 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                    return -1;
                  return 206; /* call_symref_pic */

                case 1:
                  return 209; /* call_reg_pic */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x3, 0) != 1L)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (pattern19 (x6, 
1) != 0)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != USE)
                return -1;
              x12 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x12) != USE)
                return -1;
              x2 = XVECEXP (x1, 0, 5);
              if (GET_CODE (x2) != CLOBBER)
                return -1;
              x17 = XEXP (x11, 0);
              operands[0] = x17;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              x18 = XEXP (x12, 0);
              operands[1] = x18;
              if (!pmode_register_operand (operands[1], E_VOIDmode))
                return -1;
              x20 = XEXP (x13, 0);
              operands[2] = x20;
              if (!pmode_register_operand (operands[2], E_VOIDmode))
                return -1;
              x21 = XEXP (x2, 0);
              operands[3] = x21;
              switch (GET_MODE (operands[3]))
                {
                case E_SImode:
                  if (!scratch_operand (operands[3], E_SImode)
                      || !
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                    return -1;
                  return 244; /* dcacheflushsi */

                case E_DImode:
                  if (!scratch_operand (operands[3], E_DImode)
                      || !
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                    return -1;
                  return 245; /* dcacheflushdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          return recog_18 (x1, insn, pnum_clobbers);

        case 4:
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != USE)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (pattern8 (x3))
            {
            case 0:
              x5 = XEXP (x3, 0);
              x7 = XEXP (x5, 0);
              switch (GET_CODE (x7))
                {
                case CONST_INT:
                case CONST_DOUBLE:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x7;
                  if (!call_operand_address (operands[0], E_VOIDmode))
                    return -1;
                  x4 = XEXP (x3, 1);
                  operands[1] = x4;
                  x6 = XVECEXP (x1, 0, 1);
                  switch (GET_CODE (x6))
                    {
                    case CLOBBER:
                      x16 = XEXP (x6, 0);
                      if (GET_CODE (x16) != REG
                          || REGNO (x16) != 1
                          || GET_MODE (x16) != E_SImode)
                        return -1;
                      x18 = XEXP (x12, 0);
                      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                        return -1;
                      x11 = XVECEXP (x1, 0, 2);
                      switch (pattern57 (x11))
                        {
                        case 0:
                          if (!
#line 7680 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                            return -1;
                          return 205; /* call_symref */

                        case 1:
                          if (!
#line 8985 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                            return -1;
                          return 220; /* sibcall_internal_symref */

                        default:
                          return -1;
                        }

                    case SET:
                      if (pattern28 (x1) != 0)
                        return -1;
                      x18 = XEXP (x12, 0);
                      if (GET_CODE (x18) != REG
                          || REGNO (x18) != 19
                          || GET_MODE (x18) != E_SImode)
                        return -1;
                      x22 = XEXP (x6, 1);
                      x23 = XEXP (x22, 1);
                      x24 = XEXP (x23, 0);
                      operands[2] = x24;
                      if (!
#line 8837 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 219; /* *call_mcount_pic_post_reload */

                    default:
                      return -1;
                    }

                case REG:
                  if (REGNO (x7) != 22
                      || GET_MODE (x7) != E_SImode)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != CLOBBER
                      || pattern10 (x1, 
1, 
2, 
CLOBBER) != 0)
                    return -1;
                  x18 = XEXP (x12, 0);
                  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x4 = XEXP (x3, 1);
                  operands[0] = x4;
                  return 208; /* call_reg */

                default:
                  return -1;
                }

            case 1:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern7 (x6, 
1, 
CLOBBER) != 0)
                return -1;
              x18 = XEXP (x12, 0);
              if (GET_CODE (x18) != CONST_INT)
                return -1;
              switch (pattern49 (x3))
                {
                case 0:
                  if (XWINT (x18, 0) != 0L)
                    return -1;
                  x4 = XEXP (x3, 1);
                  x25 = XEXP (x4, 1);
                  operands[2] = x25;
                  x11 = XVECEXP (x1, 0, 2);
                  switch (pattern57 (x11))
                    {
                    case 0:
                      if (!
#line 8168 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 211; /* call_val_symref */

                    case 1:
                      if (!
#line 9072 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
                        return -1;
                      return 221; /* sibcall_value_internal_symref */

                    default:
                      return -1;
                    }

                case 1:
                  x11 = XVECEXP (x1, 0, 2);
                  if (pattern9 (x11, 
2, 
CLOBBER) != 0
                      || XWINT (x18, 0) != 1L)
                    return -1;
                  x4 = XEXP (x3, 1);
                  x25 = XEXP (x4, 1);
                  operands[1] = x25;
                  return 214; /* call_val_reg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 7:
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case CONST_INT:
              if (pnum_clobbers == NULL
                  || XWINT (x3, 0) != 2L
                  || pattern20 (x1, 
2) != 0
                  || pattern58 (x1) != 0)
                return -1;
              if (
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == SImode))
                {
                  *pnum_clobbers = 1;
                  return 246; /* icacheflushsi */
                }
              if (!
#line 125 "../../gcc/config/pa/pa.md"
(Pmode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 247; /* icacheflushdi */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x3, 0) != 1
                  || XINT (x3, 1) != 3)
                return -1;
              x26 = XVECEXP (x3, 0, 0);
              if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x16 = XEXP (x6, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 31
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != CLOBBER
                  || pattern53 (x1, 
20, 
21, 
22) != 0)
                return -1;
              x21 = XEXP (x2, 0);
              if (GET_CODE (x21) != REG
                  || REGNO (x21) != 19
                  || GET_MODE (x21) != E_SImode)
                return -1;
              x19 = XEXP (x14, 0);
              if (GET_CODE (x19) != REG
                  || REGNO (x19) != 1
                  || GET_MODE (x19) != E_SImode)
                return -1;
              return 248; /* outline_prologue_call */

            default:
              return -1;
            }

        case 10:
          x3 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x3) != UNSPEC_VOLATILE
              || XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 4)
            return -1;
          x26 = XVECEXP (x3, 0, 0);
          if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern26 (x1, 
USE, 
29) != 0
              || pattern45 (x1, 
CLOBBER, 
28) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 3);
          x18 = XEXP (x12, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 31
              || GET_MODE (x18) != E_SImode)
            return -1;
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != CLOBBER)
            return -1;
          x20 = XEXP (x13, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 22
              || GET_MODE (x20) != E_SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x21 = XEXP (x2, 0);
          if (GET_CODE (x21) != REG
              || REGNO (x21) != 21
              || GET_MODE (x21) != E_SImode)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x19 = XEXP (x14, 0);
          if (GET_CODE (x19) != REG
              || REGNO (x19) != 20
              || GET_MODE (x19) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 7);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 19
              || GET_MODE (x10) != E_SImode)
            return -1;
          x15 = XVECEXP (x1, 0, 8);
          if (GET_CODE (x15) != CLOBBER)
            return -1;
          x27 = XEXP (x15, 0);
          if (GET_CODE (x27) != REG
              || REGNO (x27) != 2
              || GET_MODE (x27) != E_SImode)
            return -1;
          x28 = XVECEXP (x1, 0, 9);
          if (GET_CODE (x28) != CLOBBER)
            return -1;
          x29 = XEXP (x28, 0);
          if (GET_CODE (x29) != REG
              || REGNO (x29) != 1
              || GET_MODE (x29) != E_SImode)
            return -1;
          return 249; /* outline_epilogue_call */

        default:
          return -1;
        }

    case TRAP_IF:
      x30 = XEXP (x1, 0);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x31 = XEXP (x1, 1);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 127; /* trap */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 0:
          x3 = XVECEXP (x1, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          return 198; /* blockage */

        case 3:
          if (pnum_clobbers == NULL)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          *pnum_clobbers = 6;
          return 248; /* outline_prologue_call */

        case 7:
          if (pnum_clobbers == NULL)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 10915 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && !TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 270; /* set_fpsr_32 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 1)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 7406 "../../gcc/config/pa/pa.md"
(GET_MODE (operands[0]) == word_mode))
        return -1;
      return 201; /* indirect_goto */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 222; /* nop */

    case PREFETCH:
      x30 = XEXP (x1, 0);
      operands[0] = x30;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      x31 = XEXP (x1, 1);
      operands[1] = x31;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x32 = XEXP (x1, 2);
      operands[2] = x32;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 10304 "../../gcc/config/pa/pa.md"
(TARGET_PA_20))
        return -1;
      return 251; /* prefetch_20 */

    default:
      return -1;
    }
}
